using System;
using System.Drawing;
using System.Windows.Forms;

using Emgu.CV;
using Emgu.CV.Structure;
using Emgu.CV.UI;
using System.Diagnostics;

namespace TestProject
{
    /// <summary>
    /// α׷
    /// </summary>
    static class Program
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region α׷ ϱ - Main()

        /// <summary>
        /// α׷ ϱ
        /// </summary>
        [STAThread]
        private static void Main()
        {
            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);
            Run();
        }

        #endregion

        #region ϱ - Run()

        /// <summary>
        /// ϱ
        /// </summary>
        private static void Run()
        {
            using(Image<Bgr, Byte> image = new Image<Bgr, byte>("cat.jpg"))
            {
                using(LatentSvmDetector detector = new LatentSvmDetector("cat.xml"))
                {
                    Stopwatch stopwatch = Stopwatch.StartNew();

                    MCvObjectDetection[] objectDetectionArray = detector.Detect(image, 0.5f);

                    stopwatch.Stop();

                    foreach(MCvObjectDetection objectDetection in objectDetectionArray)
                    {
                        if(objectDetection.score > -0.5)
                        {
                            image.Draw(objectDetection.Rect, new Bgr(Color.Red), 1);
                        }
                    }

                    ImageViewer.Show(image, String.Format("ü Ž : {0} и", stopwatch.ElapsedMilliseconds));
                }
            }
        }

        #endregion
    }
}